/******************************************************************************/
/* AGENT2B                                                                    */
/*                                                                            */
/* Pedidos                                                                    */
/******************************************************************************/
/*                                                                            */
/* Nome: RETORNA_RENTABILIDADE_PED                                            */
/*                                                                            */
/* Criao:                                                                   */
/*    31/01/2011 - Welbert G. Moitinha                                        */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE FUNCTION RETORNA_RENTABILIDADE_PED( P_CDFILIAL   IN PEDIDO.CDFILIAL%TYPE,
                                    P_NRPEDIDO   IN PEDIDO.NRPEDIDO%TYPE )RETURN FLOAT
AS
   V_VRTOTALBRUTO  FLOAT;
   V_VRTOTALLIQUI  FLOAT;
   V_VRTOTCUSTPRODBASE  FLOAT;
   V_TOTALLUCRO FLOAT;
   V_VRCORRENT FLOAT;
   V_VRITRENTABIL FLOAT;
   V_CDPRECOBASE PRECOBASE.CDPRECOBASE%TYPE;
   V_IDEXIBRENTPED PARAMPEDIDO.IDEXIBRENTPED%TYPE;
BEGIN
   V_VRTOTALBRUTO := 0;
   V_VRTOTALLIQUI := 0;
   V_VRTOTCUSTPRODBASE := 0;
   V_TOTALLUCRO := 0;
   V_VRITRENTABIL := 0;
   V_VRCORRENT := NULL;

   SELECT MAX(IDEXIBRENTPED)
     INTO V_IDEXIBRENTPED
     FROM PARAMPEDIDO
    WHERE CDFILIAL = P_CDFILIAL;

   IF (V_IDEXIBRENTPED = 'S') THEN

      SELECT MAX(CDPRECOBASE)
        INTO V_CDPRECOBASE
        FROM PEDIDO
       WHERE CDFILIAL = P_CDFILIAL
         AND NRPEDIDO = P_NRPEDIDO;

      FOR C_REG IN(SELECT I.CDPRODUTO, NVL(QTITEMPED, 0) AS QTITEMPED, NVL(VRPREUNITPED, 0) AS VRPREUNITPED, 
                          NVL(VRDESITPED, 0) AS VRDESITPED, NVL(VRPERCMARKUPIT, 0) AS VRPERCMARKUPIT,
                          NVL(VRPRTABITPED, 0) AS VRPRTABITPED, NVL(VRCUSTPRODBASE, 0) AS VRCUSTPRODBASE,
                          (SELECT MAX(NVL(VRPEFORMPREC, 0))
                             FROM PARAMPEDIDO R, FORMPRECPROD FP
                            WHERE R.CDFILIAL = P_CDFILIAL
                              AND FP.CDFILIAL = R.CDFILIAL
                              AND FP.CDPRODUTO = I.CDPRODUTO) AS VRPEFORMPREC
                     FROM ITEMPEDIDO I, ITEMPREBASE H
                    WHERE CDFILIAL = P_CDFILIAL
                      AND NRPEDIDO = P_NRPEDIDO
                      AND I.CDPRODUTO = H.CDPRODUTO
                      AND H.CDPRECOBASE  = V_CDPRECOBASE
                    ORDER BY NRITEMPED) LOOP

         V_VRTOTALBRUTO := (C_REG.QTITEMPED * ROUND(C_REG.VRPREUNITPED,2));
         V_VRTOTALLIQUI := (C_REG.QTITEMPED * ROUND(C_REG.VRPREUNITPED,2) - (TRUNC(C_REG.VRDESITPED*100)/100));

         IF C_REG.VRPERCMARKUPIT > 0 THEN
            V_VRTOTALLIQUI := V_VRTOTALLIQUI + ((V_VRTOTALBRUTO *C_REG.VRPERCMARKUPIT)/100);
         END IF;

         V_VRTOTCUSTPRODBASE := V_VRTOTCUSTPRODBASE +(C_REG.VRCUSTPRODBASE* C_REG.QTITEMPED);
         V_TOTALLUCRO := V_TOTALLUCRO + (((C_REG.VRPEFORMPREC *C_REG.VRCUSTPRODBASE)/100)* C_REG.QTITEMPED)+ (V_VRTOTALLIQUI - C_REG.VRPRTABITPED*C_REG.QTITEMPED);
      END LOOP;

      IF V_VRTOTCUSTPRODBASE <> 0 THEN
         BEGIN
            SELECT MAX(VRCORRENT)
              INTO V_VRCORRENT
              FROM RENTABILIDADE
             WHERE ((V_TOTALLUCRO*100)/V_VRTOTCUSTPRODBASE)  BETWEEN VRPERCINIRENT AND VRPERCFIMRENT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRCORRENT := NULL;
         END;
      END IF;
      
   ELSIF (V_IDEXIBRENTPED = 'F') THEN
   
      BEGIN
         SELECT AVG(VRITRENTABIL)
           INTO V_VRITRENTABIL
           FROM ITEMPEDIDO
          WHERE (CDFILIAL = P_CDFILIAL)
            AND (NRPEDIDO = P_NRPEDIDO);
      EXCEPTION
           WHEN NO_DATA_FOUND THEN
            V_VRITRENTABIL := 0;
      END;   
   
      IF (V_VRITRENTABIL <> 0) THEN
         BEGIN
            SELECT MAX(VRCORRENT)
              INTO V_VRCORRENT
              FROM RENTABILIDADE
             WHERE (V_VRITRENTABIL  BETWEEN VRPERCINIRENT AND VRPERCFIMRENT);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRCORRENT := NULL;
         END;
      END IF;
   ELSE
      V_VRCORRENT := 0;
   END IF;
   RETURN(V_VRCORRENT);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('RETORNA_RENTABILIDADE_PED','6.19.000'); END;
/
